package common.http;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import org.apache.log4j.Logger;

/**
 * <pre>
 *         Copyright (c) 2006 Dominik Schulz
 *         Copyright (c) 2006 Florian Lindner
 *         Copyright (c) 2006 Philip Hartmann
 *
 *         This file is part of jHTTPd.
 *
 *         jHTTPd is free software; you can redistribute it and/or modify
 *         it under the terms of the GNU General Public License as published by
 *         the Free Software Foundation; either version 2 of the License, or
 *         (at your option) any later version.
 *
 *         jHTTPd is distributed in the hope that it will be useful,
 *         but WITHOUT ANY WARRANTY; without even the implied warranty of
 *         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *         GNU General Public License for more details.
 *
 *         You should have received a copy of the GNU General Public License
 *         along with jHTTPd; if not, write to the Free Software
 *         Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * </pre>
 *
 * NOTE: This class is not used in the jUPnP Project! It should have been removed long ago ... ;)
 *
 * @author Dominik
 *
 * "The chief export of Chuck Norris is Pain."
 */
public class ControlThread implements Runnable {

	private ConfigHttpd	configHttpd	= null;

	static Logger		logger		= Logger.getLogger(ControlThread.class);

	/**
	 * The Controlthread is rsponsable for handling user requests (inputs)
	 */
	public void run() {
		for (;;) {
			// open a reader on the standard input
			BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
			String input = "";
			try {
				input = br.readLine();
			} catch (IOException ioe) {
				logger.trace("IOException occurred ", ioe);
			}
			if (input.toLowerCase().equals(ConfigHttpd.CMD_QUIT.toLowerCase())) {
				System.out.println("Shutting down ...");
				System.exit(0);
			} else if (input.toLowerCase().equals(ConfigHttpd.CMD_STATUS.toLowerCase())) {
				System.out.println("Running Threads: " + configHttpd.getRunningThreads());
			} else if (input.toLowerCase().equals(ConfigHttpd.CMD_CONFIG.toLowerCase())) {
				System.out.println("Current Configuration:");
				System.out.println("Port: " + configHttpd.getPort());
				System.out.println("ServerRoot: " + configHttpd.getServerRoot());
				System.out.println("Default Charset: " + configHttpd.getDefaultCharset());
				System.out.println("Default MIME-Type: " + configHttpd.getMimeType());
				System.out.println("Directory List View: " + configHttpd.isDirectoryListView());
			} else if (input.toLowerCase().equals(ConfigHttpd.CMD_MIME.toLowerCase())) {
				// Not implemented
			}

			// Sleep
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				logger.trace("InterruptException occurred ", e);
			}
		}
	}

}
