/*
 * Created on 26.10.2006
 */
package common.http;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;

import org.apache.log4j.Logger;

/**
 * <pre>
 *         Copyright (c) 2007 Dominik Schulz
 *         Copyright (c) 2007 Florian Lindner
 *         Copyright (c) 2007 Philip Hartmann
 *
 *         This file is part of jHTTPd.
 *
 *         jHTTPd is free software; you can redistribute it and/or modify
 *         it under the terms of the GNU General Public License as published by
 *         the Free Software Foundation; either version 2 of the License, or
 *         (at your option) any later version.
 *
 *         jHTTPd is distributed in the hope that it will be useful,
 *         but WITHOUT ANY WARRANTY; without even the implied warranty of
 *         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *         GNU General Public License for more details.
 *
 *         You should have received a copy of the GNU General Public License
 *         along with jHTTPd; if not, write to the Free Software
 *         Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * </pre>
 *
 * @author Dominik
 *
 * "Chuck Norris has two speeds. Walk, and Kill."
 */
public class Header {

	static Logger		logger		= Logger.getLogger(Header.class);

	OutputStream		os			= null;

	/**
	 * An arrayList that contains the headerlines
	 */
	ArrayList<String>	headerLines	= new ArrayList<String>();

	/**
	 *
	 * @param os
	 *            An Output stream into which the header will be written later.
	 */
	public Header(OutputStream os) {
		this.os = os;
	}

	/**
	 * Adds a new header line. The Line feed will be added later by this class.
	 *
	 * @param line
	 */
	public void addHeaderLine(String line) {
		headerLines.add(line);
	}

	/**
	 * Finalizes the Header and writes it to the output stream.
	 *
	 * @return
	 * @throws IOException
	 */
	public boolean sendHeader() throws IOException {
		for (int i = 0; i < headerLines.size(); i++) {
			os.write((headerLines.get(i) + ConfigHttpd.CRLF).getBytes());
		}
		// Send a blank line to indicate the end of the header lines.
		os.write(ConfigHttpd.CRLF.getBytes());
		return true;
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < headerLines.size(); i++) {
			sb.append(headerLines.get(i) + "\n");
		}
		return sb.toString();
	}

}
