/*
 * Created on 19.12.2006
 *
 */
package controlpoint.multicast;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.MulticastSocket;

import org.apache.log4j.Logger;

import common.core.Config;
import common.http.ConfigHttpd;

/**
 * <pre>
 *          Copyright (c) 2007 Dominik Schulz
 *          Copyright (c) 2007 Florian Lindner
 *          Copyright (c) 2007 Philip Hartmann
 *
 *          This file is part of jUPnP.
 *
 *          jUPnP is free software; you can redistribute it and/or modify
 *          it under the terms of the GNU General Public License as published by
 *          the Free Software Foundation; either version 2 of the License, or
 *          (at your option) any later version.
 *
 *          jUPnP is distributed in the hope that it will be useful,
 *          but WITHOUT ANY WARRANTY; without even the implied warranty of
 *          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *          GNU General Public License for more details.
 *
 *          You should have received a copy of the GNU General Public License
 *          along with jUPnP; if not, write to the Free Software
 *          Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * </pre>
 *
 * @author tex
 *
 * "Chuck Norris doesnt wear a watch, HE decides what time it is."
 */
public class DiscoverThread implements Runnable {

	static Logger	logger	= Logger.getLogger(DiscoverThread.class);

	private Config	config	= null;

	/**
	 *
	 * @param conf
	 *            Our config
	 */
	public DiscoverThread(Config conf) {
		this.config = conf;
	}

	/**
	 * starting the dicover thread
	 */
	public void run() {
		// create a discovery message
		String discoverMessage = "";
		discoverMessage = "M-SEARCH * HTTP/" + ConfigHttpd.HTTP_VERSION + Config.CRLF;
		discoverMessage += "MX: 10" + Config.CRLF;
		discoverMessage += "ST: ssdp:all" + Config.CRLF;
		discoverMessage += "HOST: 239.255.255.250:1900" + Config.CRLF;
		discoverMessage += "MAN: \"ssdp:discover\"" + Config.CRLF;
		discoverMessage += Config.CRLF;

		DatagramPacket discoverPacket = new DatagramPacket(discoverMessage.getBytes(),
				discoverMessage.getBytes().length, this.config.getGroup(), Config.MULTICAST_PORT);
		// send it via a multicast socket
		MulticastSocket ms = this.config.getMcSocket();
		logger.trace("run() - Sending: " + discoverMessage);
		try {
			ms.send(discoverPacket);
		} catch (IOException e) {
			logger.error(e);
		}

	}

}
