/*
 * Created on 12.01.2007
 *
 */
package controlpoint.multicast;

import java.io.IOException;
import java.net.URL;

import org.apache.log4j.Logger;

import common.core.Config;
import common.http.CustomHttpRequest;

/**
 * <pre>
 *          Copyright (c) 2007 Dominik Schulz
 *          Copyright (c) 2007 Florian Lindner
 *          Copyright (c) 2007 Philip Hartmann
 *
 *          This file is part of jUPnP.
 *
 *          jUPnP is free software; you can redistribute it and/or modify
 *          it under the terms of the GNU General Public License as published by
 *          the Free Software Foundation; either version 2 of the License, or
 *          (at your option) any later version.
 *
 *          jUPnP is distributed in the hope that it will be useful,
 *          but WITHOUT ANY WARRANTY; without even the implied warranty of
 *          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *          GNU General Public License for more details.
 *
 *          You should have received a copy of the GNU General Public License
 *          along with jUPnP; if not, write to the Free Software
 *          Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * </pre>
 *
 * @author tex
 *
 * "Chuck Norris does not own a stove, oven, or microwave , because revenge is a dish best served cold."
 */
public class EventUnsubscribeThread implements Runnable {

	@SuppressWarnings("unused")
	private Config	config	= null;

	static Logger	logger	= Logger.getLogger(EventUnsubscribeThread.class);

	private URL		target	= null;

	private String	sid		= "";

	/**
	 *
	 * @param conf
	 * @param url
	 * @param sid
	 */
	public EventUnsubscribeThread(Config conf, URL url, String sid) {
		this.config = conf;
		this.target = url;
		this.sid = sid;
	}

	public void run() {
		// create and send an unsubscribe request
		try {
			CustomHttpRequest req = new CustomHttpRequest(this.target, "UNSUBSCRIBE");
			req.addHeaderLine("SID: " + this.sid);
			req.addHeaderLine("NT: upnp:event");
			req.sendRequest();
		} catch (IOException e) {
			logger.trace("IOException occurred ", e);
		}

	}

}
