/*
 * Created on 11.01.2007
 *
 */
package controlpoint.soap;

import org.apache.log4j.Logger;

/**
 * <pre>
 *          Copyright (c) 2007 Dominik Schulz
 *          Copyright (c) 2007 Florian Lindner
 *          Copyright (c) 2007 Philip Hartmann
 *
 *          This file is part of jUPnP.
 *
 *          jUPnP is free software; you can redistribute it and/or modify
 *          it under the terms of the GNU General Public License as published by
 *          the Free Software Foundation; either version 2 of the License, or
 *          (at your option) any later version.
 *
 *          jUPnP is distributed in the hope that it will be useful,
 *          but WITHOUT ANY WARRANTY; without even the implied warranty of
 *          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *          GNU General Public License for more details.
 *
 *          You should have received a copy of the GNU General Public License
 *          along with jUPnP; if not, write to the Free Software
 *          Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * </pre>
 *
 * @author tex
 *
 * "Contrary to popular belief, America is not a democracy, it is a Chucktatorship."
 */
public class SOAPSimpleLightApiRunnerThread implements Runnable {

	private SOAPSimpleLightApi	ssla		= null;

	private String				command		= "";

	private int					parameter	= 0;

	private int					returnValue	= 0;

	static Logger				logger		= Logger.getLogger(SOAPSimpleLightApiRunnerThread.class);

	/**
	 *
	 * @param ssla
	 * @param command
	 * @param parameter
	 */
	public SOAPSimpleLightApiRunnerThread(SOAPSimpleLightApi ssla, String command, int parameter) {
		this.ssla = ssla;
		this.command = command;
		this.parameter = parameter;
	}

	/**
	 * @return the returnValue
	 */
	public int getReturnValue() {
		while (Thread.currentThread().isAlive()) {
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				logger.trace("InterruptException occurred ", e);
			}
		}
		return returnValue;
	}

	public void run() {
		if (command == "switchOn") {
			ssla.switchOn();
		} else if (command == "switchOff") {
			ssla.switchOff();
		} else if (command == "getSwitchStatus") {
			this.returnValue = Integer.parseInt(ssla.getSwitchStatus());
		} else if (command == "setDimmingLevel") {
			ssla.setDimmingLevel(parameter);
		} else if (command == "getDimmingLevel") {
			this.returnValue = ssla.getDimmingLevel();
		}
	}

}
